--[[
    This file is part of Decursive.
    
    Decursive (v 2.7.0.4) add-on for World of Warcraft UI
    Copyright (C) 2006-2007-2008-2009-2010-2011 John Wellesz (archarodim AT teaser.fr) ( http://www.2072productions.com/to/decursive.php )

    Starting from 2009-10-31 and until said otherwise by its author, Decursive
    is no longer free software, all rights are reserved to its author (John
    Wellesz).

    The only official and allowed distribution means are
    www.2072productions.com, www.wowace.com and curse.com.
    To distribute Decursive through other means a special authorization is
    required.
    

    Decursive is inspired from the original "Decursive v1.9.4" by Quu.
    The original "Decursive 1.9.4" is in public domain ( www.quutar.com )

    Decursive is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY.

    This file was last updated on 2011-11-06T13:37:21Z
--]]
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-- Brazilian Portuguese localization
-------------------------------------------------------------------------------

--[=[
--                      YOUR ATTENTION PLEASE
--
--         !!!!!!! TRANSLATORS TRANSLATORS TRANSLATORS !!!!!!!
--
--    Thank you very much for your interest in translating Decursive.
--    Do not edit those files. Use the localization interface available at the following address:
--
--      ################################################################
--      #  http://wow.curseforge.com/projects/decursive/localization/  #
--      ################################################################
--
--    Your translations made using this interface will be automatically included in the next release.
--
--]=]

local addonName, T = ...;
-- big ugly scary fatal error message display function {{{
if not T._FatalError then
-- the beautiful error popup : {{{ -
StaticPopupDialogs["DECURSIVE_ERROR_FRAME"] = {
    text = "|cFFFF0000Decursive Error:|r\n%s",
    button1 = "OK",
    OnAccept = function()
        return false;
    end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1,
    showAlert = 1,
    }; -- }}}
T._FatalError = function (TheError) StaticPopup_Show ("DECURSIVE_ERROR_FRAME", TheError); end
end
-- }}}
if not T._LoadedFiles or not T._LoadedFiles["enUS.lua"] then
    if not DecursiveInstallCorrupted then T._FatalError("Decursive installation is corrupted! (enUS.lua not loaded)"); end;
    DecursiveInstallCorrupted = true;
    return;
end

local L = LibStub("AceLocale-3.0"):NewLocale("Decursive", "ptBR");

if not L then 
    T._LoadedFiles["ptBR.lua"] = "2.7.0.4";
    return;
end

-- L["ABOLISH_CHECK"] = ""
-- L["ABOUT_AUTHOREMAIL"] = ""
-- L["ABOUT_CREDITS"] = ""
-- L["ABOUT_LICENSE"] = ""
-- L["ABOUT_NOTES"] = ""
-- L["ABOUT_OFFICIALWEBSITE"] = ""
-- L["ABOUT_SHAREDLIBS"] = ""
L["ABSENT"] = "Faltando (%s)" -- Needs review
-- L["AFFLICTEDBY"] = ""
L["ALT"] = "Alt" -- Needs review
-- L["AMOUNT_AFFLIC"] = ""
L["ANCHOR"] = "Âncora de texto do Decursive" -- Needs review
L["BINDING_NAME_DCRMUFSHOWHIDE"] = "Mostrar ou esconder os micro quadros de unidades." -- Needs review
L["BINDING_NAME_DCRPRADD"] = "Adicionar alvo na lista de prioridades"
L["BINDING_NAME_DCRPRCLEAR"] = "Limpar a lista de prioridades"
L["BINDING_NAME_DCRPRLIST"] = "Imprimir a lista de prioridades"
L["BINDING_NAME_DCRPRSHOW"] = "Mostrar ou esconder a lista de prioridade" -- Needs review
L["BINDING_NAME_DCRSHOW"] = [=[Mostrar ou esconder a Barra Principal do Decursive
(âncora de lista ao vivo)]=] -- Needs review
-- L["BINDING_NAME_DCRSHOWOPTION"] = ""
-- L["BINDING_NAME_DCRSKADD"] = ""
-- L["BINDING_NAME_DCRSKCLEAR"] = ""
-- L["BINDING_NAME_DCRSKLIST"] = ""
-- L["BINDING_NAME_DCRSKSHOW"] = ""
-- L["BLACKLISTED"] = ""
-- L["BLACK_LENGTH"] = ""
-- L["CHARM"] = ""
L["CLASS_HUNTER"] = "Caçador"
-- L["CLEAR_PRIO"] = ""
-- L["CLEAR_SKIP"] = ""
-- L["COLORALERT"] = ""
-- L["COLORCHRONOS"] = ""
-- L["COLORCHRONOS_DESC"] = ""
-- L["COLORSTATUS"] = ""
-- L["CTRL"] = ""
-- L["CURE_PETS"] = ""
-- L["CURSE"] = ""
-- L["DEBUG_REPORT_HEADER"] = ""
-- L["DECURSIVE_DEBUG_REPORT"] = ""
-- L["DECURSIVE_DEBUG_REPORT_NOTIFY"] = ""
-- L["DECURSIVE_DEBUG_REPORT_SHOW"] = ""
-- L["DECURSIVE_DEBUG_REPORT_SHOW_DESC"] = ""
-- L["DEFAULT_MACROKEY"] = ""
-- L["DEV_VERSION_ALERT"] = ""
-- L["DEV_VERSION_EXPIRED"] = ""
-- L["DEWDROPISGONE"] = ""
-- L["DISABLEWARNING"] = ""
-- L["DISEASE"] = ""
-- L["DONOT_BL_PRIO"] = ""
-- L["DONT_SHOOT_THE_MESSENGER"] = ""
-- L["FAILEDCAST"] = ""
-- L["FOCUSUNIT"] = ""
-- L["FUBARMENU"] = ""
-- L["FUBARMENU_DESC"] = ""
-- L["GLOR1"] = ""
-- L["GLOR2"] = ""
-- L["GLOR3"] = ""
-- L["GLOR4"] = ""
-- L["GLOR5"] = ""
-- L["HANDLEHELP"] = ""
-- L["HIDESHOW_BUTTONS"] = ""
-- L["HIDE_LIVELIST"] = ""
-- L["HIDE_MAIN"] = ""
-- L["HLP_LEFTCLICK"] = ""
-- L["HLP_LL_ONCLICK_TEXT"] = ""
-- L["HLP_MIDDLECLICK"] = ""
-- L["HLP_NOTHINGTOCURE"] = ""
-- L["HLP_RIGHTCLICK"] = ""
-- L["HLP_USEXBUTTONTOCURE"] = ""
-- L["HLP_WRONGMBUTTON"] = ""
-- L["IGNORE_STEALTH"] = ""
-- L["IS_HERE_MSG"] = ""
-- L["LIST_ENTRY_ACTIONS"] = ""
-- L["MACROKEYALREADYMAPPED"] = ""
-- L["MACROKEYMAPPINGFAILED"] = ""
-- L["MACROKEYMAPPINGSUCCESS"] = ""
-- L["MACROKEYNOTMAPPED"] = ""
-- L["MAGIC"] = ""
-- L["MAGICCHARMED"] = ""
-- L["MISSINGUNIT"] = ""
-- L["NEW_VERSION_ALERT"] = ""
-- L["NORMAL"] = ""
-- L["NOSPELL"] = ""
-- L["OPTION_MENU"] = ""
-- L["OPT_ABOLISHCHECK_DESC"] = ""
-- L["OPT_ABOUT"] = ""
-- L["OPT_ADDDEBUFF"] = ""
-- L["OPT_ADDDEBUFFFHIST"] = ""
-- L["OPT_ADDDEBUFFFHIST_DESC"] = ""
-- L["OPT_ADDDEBUFF_DESC"] = ""
-- L["OPT_ADDDEBUFF_USAGE"] = ""
-- L["OPT_ADD_A_CUSTOM_SPELL"] = ""
-- L["OPT_ADD_A_CUSTOM_SPELL_DESC"] = ""
-- L["OPT_ADVDISP"] = ""
-- L["OPT_ADVDISP_DESC"] = ""
-- L["OPT_AFFLICTEDBYSKIPPED"] = ""
-- L["OPT_ALLOWMACROEDIT"] = ""
-- L["OPT_ALLOWMACROEDIT_DESC"] = ""
-- L["OPT_ALWAYSIGNORE"] = ""
-- L["OPT_ALWAYSIGNORE_DESC"] = ""
-- L["OPT_AMOUNT_AFFLIC_DESC"] = ""
-- L["OPT_ANCHOR_DESC"] = ""
-- L["OPT_AUTOHIDEMFS"] = ""
-- L["OPT_AUTOHIDEMFS_DESC"] = ""
-- L["OPT_BLACKLENTGH_DESC"] = ""
-- L["OPT_BORDERTRANSP"] = ""
-- L["OPT_BORDERTRANSP_DESC"] = ""
-- L["OPT_CENTERTRANSP"] = ""
-- L["OPT_CENTERTRANSP_DESC"] = ""
-- L["OPT_CHARMEDCHECK_DESC"] = ""
-- L["OPT_CHATFRAME_DESC"] = ""
-- L["OPT_CHECKOTHERPLAYERS"] = ""
-- L["OPT_CHECKOTHERPLAYERS_DESC"] = ""
-- L["OPT_CMD_DISBLED"] = ""
-- L["OPT_CMD_ENABLED"] = ""
-- L["OPT_CREATE_VIRTUAL_DEBUFF"] = ""
-- L["OPT_CREATE_VIRTUAL_DEBUFF_DESC"] = ""
-- L["OPT_CUREPETS_DESC"] = ""
-- L["OPT_CURE_PRIORITY_NUM"] = ""
-- L["OPT_CURINGOPTIONS"] = ""
-- L["OPT_CURINGOPTIONS_DESC"] = ""
-- L["OPT_CURINGOPTIONS_EXPLANATION"] = ""
-- L["OPT_CURINGORDEROPTIONS"] = ""
-- L["OPT_CURSECHECK_DESC"] = ""
-- L["OPT_CUSTOMSPELLS"] = ""
-- L["OPT_CUSTOMSPELLS_DESC"] = ""
-- L["OPT_CUSTOMSPELLS_EFFECTIVE_ASSIGNMENTS"] = ""
-- L["OPT_CUSTOM_SPELL_ALLOW_EDITING"] = ""
-- L["OPT_CUSTOM_SPELL_ALLOW_EDITING_DESC"] = ""
-- L["OPT_CUSTOM_SPELL_CURE_TYPES"] = ""
-- L["OPT_CUSTOM_SPELL_IS_DEFAULT"] = ""
-- L["OPT_CUSTOM_SPELL_MACRO_MISSING_NOMINAL_SPELL"] = ""
-- L["OPT_CUSTOM_SPELL_MACRO_MISSING_UNITID_KEYWORD"] = ""
-- L["OPT_CUSTOM_SPELL_MACRO_TEXT"] = ""
-- L["OPT_CUSTOM_SPELL_MACRO_TEXT_DESC"] = ""
-- L["OPT_CUSTOM_SPELL_MACRO_TOO_LONG"] = ""
-- L["OPT_CUSTOM_SPELL_PRIORITY"] = ""
-- L["OPT_CUSTOM_SPELL_PRIORITY_DESC"] = ""
-- L["OPT_CUSTOM_SPELL_STOPCASTING"] = ""
-- L["OPT_CUSTOM_SPELL_STOPCASTING_DESC"] = ""
-- L["OPT_CUSTOM_SPELL_UNAVAILABLE"] = ""
-- L["OPT_DEBCHECKEDBYDEF"] = ""
-- L["OPT_DEBUFFENTRY_DESC"] = ""
-- L["OPT_DEBUFFFILTER"] = ""
-- L["OPT_DEBUFFFILTER_DESC"] = ""
-- L["OPT_DELETE_A_CUSTOM_SPELL"] = ""
-- L["OPT_DISABLEABOLISH"] = ""
-- L["OPT_DISABLEABOLISH_DESC"] = ""
-- L["OPT_DISABLEMACROCREATION"] = ""
-- L["OPT_DISABLEMACROCREATION_DESC"] = ""
-- L["OPT_DISEASECHECK_DESC"] = ""
-- L["OPT_DISPLAYOPTIONS"] = ""
-- L["OPT_DONOTBLPRIO_DESC"] = ""
-- L["OPT_ENABLEDEBUG"] = ""
-- L["OPT_ENABLEDEBUG_DESC"] = ""
-- L["OPT_ENABLEDECURSIVE"] = ""
-- L["OPT_ENABLE_A_CUSTOM_SPELL"] = ""
-- L["OPT_FILTEROUTCLASSES_FOR_X"] = ""
-- L["OPT_GENERAL"] = ""
-- L["OPT_GROWDIRECTION"] = ""
-- L["OPT_GROWDIRECTION_DESC"] = ""
-- L["OPT_HIDELIVELIST_DESC"] = ""
-- L["OPT_HIDEMFS_GROUP"] = ""
-- L["OPT_HIDEMFS_GROUP_DESC"] = ""
-- L["OPT_HIDEMFS_NEVER"] = ""
-- L["OPT_HIDEMFS_NEVER_DESC"] = ""
-- L["OPT_HIDEMFS_SOLO"] = ""
-- L["OPT_HIDEMFS_SOLO_DESC"] = ""
-- L["OPT_HIDEMUFSHANDLE"] = ""
-- L["OPT_HIDEMUFSHANDLE_DESC"] = ""
-- L["OPT_IGNORESTEALTHED_DESC"] = ""
-- L["OPT_INPUT_SPELL_BAD_INPUT_ALREADY_HERE"] = ""
-- L["OPT_INPUT_SPELL_BAD_INPUT_DEFAULT_SPELL"] = ""
-- L["OPT_INPUT_SPELL_BAD_INPUT_ID"] = ""
-- L["OPT_INPUT_SPELL_BAD_INPUT_NOT_SPELL"] = ""
-- L["OPT_LIVELIST"] = ""
-- L["OPT_LIVELIST_DESC"] = ""
-- L["OPT_LLALPHA"] = ""
-- L["OPT_LLALPHA_DESC"] = ""
-- L["OPT_LLSCALE"] = ""
-- L["OPT_LLSCALE_DESC"] = ""
-- L["OPT_LVONLYINRANGE"] = ""
-- L["OPT_LVONLYINRANGE_DESC"] = ""
-- L["OPT_MACROBIND"] = ""
-- L["OPT_MACROBIND_DESC"] = ""
-- L["OPT_MACROOPTIONS"] = ""
-- L["OPT_MACROOPTIONS_DESC"] = ""
-- L["OPT_MAGICCHARMEDCHECK_DESC"] = ""
-- L["OPT_MAGICCHECK_DESC"] = ""
-- L["OPT_MAXMFS"] = ""
-- L["OPT_MAXMFS_DESC"] = ""
-- L["OPT_MESSAGES"] = ""
-- L["OPT_MESSAGES_DESC"] = ""
-- L["OPT_MFALPHA"] = ""
-- L["OPT_MFALPHA_DESC"] = ""
-- L["OPT_MFPERFOPT"] = ""
-- L["OPT_MFREFRESHRATE"] = ""
-- L["OPT_MFREFRESHRATE_DESC"] = ""
-- L["OPT_MFREFRESHSPEED"] = ""
-- L["OPT_MFREFRESHSPEED_DESC"] = ""
-- L["OPT_MFSCALE"] = ""
-- L["OPT_MFSCALE_DESC"] = ""
-- L["OPT_MFSETTINGS"] = ""
-- L["OPT_MFSETTINGS_DESC"] = ""
-- L["OPT_MUFFOCUSBUTTON"] = ""
-- L["OPT_MUFHANDLE_HINT"] = ""
-- L["OPT_MUFMOUSEBUTTONS"] = ""
-- L["OPT_MUFMOUSEBUTTONS_DESC"] = ""
-- L["OPT_MUFSCOLORS"] = ""
-- L["OPT_MUFSCOLORS_DESC"] = ""
-- L["OPT_MUFSVERTICALDISPLAY"] = ""
-- L["OPT_MUFSVERTICALDISPLAY_DESC"] = ""
-- L["OPT_MUFTARGETBUTTON"] = ""
-- L["OPT_NEWVERSIONBUGMENOT"] = ""
-- L["OPT_NEWVERSIONBUGMENOT_DESC"] = ""
-- L["OPT_NOKEYWARN"] = ""
-- L["OPT_NOKEYWARN_DESC"] = ""
-- L["OPT_NOSTARTMESSAGES"] = ""
-- L["OPT_NOSTARTMESSAGES_DESC"] = ""
-- L["OPT_OPTIONS_DISABLED_WHILE_IN_COMBAT"] = ""
-- L["OPT_PERFOPTIONWARNING"] = ""
-- L["OPT_PLAYSOUND_DESC"] = ""
-- L["OPT_POISONCHECK_DESC"] = ""
-- L["OPT_PRINT_CUSTOM_DESC"] = ""
-- L["OPT_PRINT_ERRORS_DESC"] = ""
-- L["OPT_PROFILERESET"] = ""
-- L["OPT_RANDOMORDER_DESC"] = ""
-- L["OPT_READDDEFAULTSD"] = ""
-- L["OPT_READDDEFAULTSD_DESC1"] = ""
-- L["OPT_READDDEFAULTSD_DESC2"] = ""
-- L["OPT_REMOVESKDEBCONF"] = ""
-- L["OPT_REMOVETHISDEBUFF"] = ""
-- L["OPT_REMOVETHISDEBUFF_DESC"] = ""
-- L["OPT_RESETDEBUFF"] = ""
-- L["OPT_RESETDTDCRDEFAULT"] = ""
-- L["OPT_RESETMUFMOUSEBUTTONS"] = ""
-- L["OPT_RESETMUFMOUSEBUTTONS_DESC"] = ""
-- L["OPT_RESETOPTIONS"] = ""
-- L["OPT_RESETOPTIONS_DESC"] = ""
-- L["OPT_RESTPROFILECONF"] = ""
-- L["OPT_REVERSE_LIVELIST_DESC"] = ""
-- L["OPT_SCANLENGTH_DESC"] = ""
-- L["OPT_SHOWBORDER"] = ""
-- L["OPT_SHOWBORDER_DESC"] = ""
-- L["OPT_SHOWCHRONO"] = ""
-- L["OPT_SHOWCHRONOTIMElEFT"] = ""
-- L["OPT_SHOWCHRONOTIMElEFT_DESC"] = ""
-- L["OPT_SHOWCHRONO_DESC"] = ""
-- L["OPT_SHOWHELP"] = ""
-- L["OPT_SHOWHELP_DESC"] = ""
-- L["OPT_SHOWMFS"] = ""
-- L["OPT_SHOWMFS_DESC"] = ""
-- L["OPT_SHOWMINIMAPICON"] = ""
-- L["OPT_SHOWMINIMAPICON_DESC"] = ""
-- L["OPT_SHOWTOOLTIP_DESC"] = ""
-- L["OPT_SHOW_STEALTH_STATUS"] = ""
-- L["OPT_SHOW_STEALTH_STATUS_DESC"] = ""
-- L["OPT_STICKTORIGHT"] = ""
-- L["OPT_STICKTORIGHT_DESC"] = ""
-- L["OPT_TESTLAYOUT"] = ""
-- L["OPT_TESTLAYOUTUNUM"] = ""
-- L["OPT_TESTLAYOUTUNUM_DESC"] = ""
-- L["OPT_TESTLAYOUT_DESC"] = ""
-- L["OPT_TIECENTERANDBORDER"] = ""
-- L["OPT_TIECENTERANDBORDER_OPT"] = ""
-- L["OPT_TIEXYSPACING"] = ""
-- L["OPT_TIEXYSPACING_DESC"] = ""
-- L["OPT_TIE_LIVELIST_DESC"] = ""
-- L["OPT_UNITPERLINES"] = ""
-- L["OPT_UNITPERLINES_DESC"] = ""
-- L["OPT_USERDEBUFF"] = ""
-- L["OPT_XSPACING"] = ""
-- L["OPT_XSPACING_DESC"] = ""
-- L["OPT_YSPACING"] = ""
-- L["OPT_YSPACING_DESC"] = ""
-- L["PLAY_SOUND"] = ""
-- L["POISON"] = ""
-- L["POPULATE"] = ""
-- L["POPULATE_LIST"] = ""
-- L["PRINT_CHATFRAME"] = ""
-- L["PRINT_CUSTOM"] = ""
-- L["PRINT_ERRORS"] = ""
-- L["PRIORITY_LIST"] = ""
-- L["PRIORITY_SHOW"] = ""
-- L["RANDOM_ORDER"] = ""
-- L["REVERSE_LIVELIST"] = ""
-- L["SCAN_LENGTH"] = ""
-- L["SHIFT"] = ""
-- L["SHOW_MSG"] = ""
-- L["SHOW_TOOLTIP"] = ""
-- L["SKIP_LIST_STR"] = ""
-- L["SKIP_SHOW"] = ""
-- L["SPELL_FOUND"] = ""
-- L["STEALTHED"] = ""
-- L["STR_CLOSE"] = ""
-- L["STR_DCR_PRIO"] = ""
-- L["STR_DCR_SKIP"] = ""
-- L["STR_GROUP"] = ""
-- L["STR_OPTIONS"] = ""
-- L["STR_OTHER"] = ""
-- L["STR_POP"] = ""
-- L["STR_QUICK_POP"] = ""
-- L["SUCCESSCAST"] = ""
-- L["TARGETUNIT"] = ""
-- L["TIE_LIVELIST"] = ""
-- L["TOOFAR"] = ""
-- L["TOO_MANY_ERRORS_ALERT"] = ""
-- L["UNITSTATUS"] = ""
-- L["UNSTABLERELEASE"] = ""



T._LoadedFiles["ptBR.lua"] = "2.7.0.4";

