﻿local mod = RW:Boss("General Umbriss", "Party - Cataclysm", "Grim Batol")
local L

mod.type = "party"

mod.BossIcon = [[Interface\ICONS\Achievement_Dungeon_GrimBatol_General Umbriss]]
mod.SubCatIcon = [[Interface\ICONS\Achievement_Dungeon_GrimBatol]]

---------------------------
-- Variables

-- Blitz
local tBlitzCD, mBlitz 

-- Ground Seige
local tGroundCD, wGround

-- Frenzy
local wFrenzy

-- Bleeding Wound
local mBleeing, tBleedingCD, tBleedingDur

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(39625)
	self:SetWin()
	
	-- Blitz
	tBlitzCD		= self:CDTimer(25, 74670)
	mBlitz			= self:CastMessage(74670)
	
	-- Ground Seige
	tGroundCD		= self:CDTimer(25, 74634)
	wGround			= self:CastWarning(74634)
	
	-- Frenzy
	wFrenzy			= self:CastWarning(74853)
	
	-- Bleeding Wound
	tBleedingCD		= self:CDTimer(20, 74846)
	tBleedingDur	= self:DurTargetTimer(15, 74846)
	mBleeing		= self:TargetMessage(74846)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Blitz", 74670, 90250)
	self:Track("GroundSeige", 74634, 90249)
	self:Track("Frenzy", 74853)
	self:Track("BleedingWound", 74846, 91937)
	
	tBlitzCD:Start(20)
	tGroundCD:Start(10)
end

function mod:Blitz(event, args)
	if event == "SPELL_CAST_START" then
		tBlitzCD:Start()
		mBlitz:Show()
	end
end

function mod:GroundSeige(event, args)
	if event == "SPELL_CAST_START" then
		tGroundCD:Start()
		wGround:Show()
	end
end

function mod:Frenzy(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		wFrenzy:Show()
	end
end

function mod:BleedingWound(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		mBleeing:Show(args.dName)
		tBleedingDur:Start(args.dName)
		tBleedingCD:Start()
		
		RW.Callbacks:Fire("MPBHealthByID", self:UIDFromName(args.dName), nil, {90})
	
	elseif event == "SPELL_AURA_REMOVED" then
		tBleedingDur:Stop(args.dName)
		RW.Callbacks:Fire("MPBHealthHideByID", self:UIDFromName(args.dName))
	end
end